FROM node:14-alpine AS GetGenerator
COPY ./webfacade-api /webfacade-api
RUN cd webfacade-api && npm run fetch-generator

FROM registry.nspop.dk/tools/nspbuilder:2.0.8 AS GenerateApi
COPY --from=GetGenerator /webfacade-api /webfacade-api
WORKDIR webfacade-api
RUN sh ./generate-from-openapi.sh trunk

FROM node:14-alpine AS TSCompiler
COPY --from=GenerateApi /webfacade-api /webfacade-api
WORKDIR webfacade-api
RUN sh ./build.sh

FROM node:14-alpine
# update npm
RUN npm i npm -g
ENV NODE_ENV=development

COPY . /app
WORKDIR /app
COPY --from=TSCompiler /webfacade-api/ /app/webfacade-api/

VOLUME [ "/app/src" ]
RUN npm set-script preinstall ""
RUN npm ci --registry https://nexus.nspop.dk/nexus/repository/nsp-npm/

EXPOSE 4700 8080
CMD npm run start
